from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtCore import Qt, QMimeData
from PyQt5.QtWidgets import QTreeWidgetItem, QFrame, QFileDialog, QMessageBox
from PyQt5.QtGui import QDrag, QFont

from decode import decode_data, get_rows

class List(QtWidgets.QListWidget):

    def __init__(self, name, parent=None):
        super().__init__(parent)

        self.parent = parent

        self.setObjectName(name)

        self.setDragDropMode(self.DragDrop)
        self.setSelectionMode(self.ExtendedSelection)
        self.setAcceptDrops(True)

        self.setDefaultDropAction(QtCore.Qt.MoveAction)

        font = QFont("Consolas", 10)
        self.setFont(font)

        self.setMinimumSize(QtCore.QSize(210, 100))

        self.thing = 0



    def get_item_at(self, row):
        return self.selectedItems()[row]


    def get_thing(self):
        return self.thing


    def dragEnterEvent(self, event):
        md = event.mimeData()
        #print(f"mimeData text = '{event.mimeData().text()}'")
        bytearray = event.mimeData().data('application/x-qabstractitemmodeldatalist')
        data_items = decode_data(bytearray)
        data_item = data_items[0][0]
        #print("Drag ENTER")
        #print(f"data_items = {data_items[0][0]}")
        #print(f"data_item = {data_item.typeName()}")
        #print(f"data_item = {data_item.userType()}")
        #print(f"data_item = {data_item.value()}")
        thing = data_item.value()
        #print(F"THING: {thing}")
        #print(f"data_item = {thing.parent()}")
        nitems = len(data_items)
        total_items = nitems + self.count()
        if self.count() + nitems < 13:
            #drop_completed = True
            event.accept()
            if self.parent != None:
                self.parent.parent.statusbar.showMessage(f"")
        else:
            event.ignore()
            if self.parent != None:
                self.parent.parent.statusbar.showMessage(f"Too many parameters: {total_items}")

    def dropEvent(self, event):
        if event.source() == self:
            event.ignore
            return
        """
        if event.mimeData().hasFormat('application/x-qabstractitemmodeldatalist'):
            data = event.mimeData()
            source_item = QtGui.QStandardItemModel()
            source_item.dropMimeData(data, QtCore.Qt.CopyAction, 0,0, QtCore.QModelIndex())
            print(source_item.item(0, 0).text())
            """
        super().dropEvent(event)
        #print(f"list has {self.count()} items")
        #for i in range(self.count()):
            #print(f"{self.item(i).text()}")
        ##print(event.mimeData().text())


